// *****************************************************************************
// *	axppi02s.pas
// *
// *	AXP-PI02
// *
// *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
// *
// *	Date 1998/10
// *
// *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
// *
// ****************************************************************************
unit Axppi02s;

interface

uses
	Windows, Messages, SysUtils, Forms,
	Axppi02w;

const
	szTitle = 'Sample';
	szPi02	= 'AXP-PI02';

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSocket: Word);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);

var
	strbuf:			String;
	wLogSocket:	Word;
	hWnd:				THandle;
	InitArg:    DWord;
	dwDLLVer:		DWord;
	dwDrvVer: 	DWord;
	ri:				 	TPI02_RESOURCE;
	bValue:			Byte;
begin
	//---------------------------------------------------------
	// Axppi02.dll ̎gp錾
	//---------------------------------------------------------
	if Pi02wDllOpen() = False Then begin
		ErrorMessage(PI02_SOCKET_AUTO);
		Exit;
	end;

	//---------------------------------------------------------
	// o[W擾
	//---------------------------------------------------------
	if Pi02wGetVersion( dwDLLVer, dwDrvVer ) = False Then begin
		ErrorMessage(PI02_SOCKET_AUTO);
		Exit;
	end;
	strbuf := Format('GetVersion'#10 +
					 'DLL Version: %08xH'#10 +
					 'Driver Version: %08xH',
										 [dwDLLVer, dwDrvVer]);

	ResultMessage(strbuf);

	//---------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------
	wLogSocket:=PI02_SOCKET_AUTO; // 󂫃foCXw
	hWnd:=0;
	InitArg:=0;
	if Pi02wCreate( wLogSocket, hWnd, 0, InitArg ) = False Then begin
		ErrorMessage(PI02_SOCKET_AUTO);
		Exit;
	end;
	strbuf := Format('AXP-PI02 Created'#10#10 +
									 'LogSocket: %2d', [wLogSocket]);
	ResultMessage(strbuf);

	//---------------------------------------------------------
	// \[X\
	//---------------------------------------------------------
	if Pi02wGetResource( wLogSocket, @ri ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;
	strbuf := Format(	'AXP-PI02 Resouce'#10#10 +
									 	'LogSocket: %02d'#10 +
                    'PortBase1: %04xh - %04xh'#10 +
                    'PortBase2: %04xh - %04xh'
                    , [wLogSocket,
										ri.dwIOPortBase[1],
										ri.dwIOPortBase[1] + ri.dwIOPortLength[1] - 1,
										ri.dwIOPortBase[2],
										ri.dwIOPortBase[2] + ri.dwIOPortLength[2] - 1]);
	ResultMessage(strbuf);

	//---------------------------------------------------------
	// 샂[h̐ݒ
	//
	// |[g`		ڂ́A戵
	// |[ga	o	ut^A. 샂[hꗗv
	// |[gb	o	QƂB
	//---------------------------------------------------------

	// fBNV15ho
	if Pi02wSetDirection( wLogSocket, $15 ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;

	// R}h|[g90ho
	if Pi02wOutPort( wLogSocket, PI02_PORT_CMD, $90 ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;

	// fBNV39ho
	if Pi02wSetDirection( wLogSocket, $39 ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;

	// fBNV28ho
	if Pi02wSetDirection( wLogSocket, $28 ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;

	strbuf := Format(	'AXP-PI02 샂[hݒ'#10#10 +
									 	'|[g`@'#10 +
									 	'|[ga@o'#10 +
									 	'|[gb@o',[bValue]);
	ResultMessage(strbuf);

	//---------------------------------------------------------
	// ͎s
	//---------------------------------------------------------
	if Pi02wInPort( wLogSocket, PI02_PORT_A, bValue ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;

	strbuf := Format(	'AXP-PI02 ͎s'#10#10 +
									 	'|[g`@%02Xh',[bValue] );
	ResultMessage(strbuf);

	//---------------------------------------------------------
	// o͎s
	//---------------------------------------------------------
	bValue:=$AA;
	if Pi02wOutPort( wLogSocket, PI02_PORT_B, bValue ) = False Then begin
		ErrorMessage( wLogSocket );
		Exit;
	end;

	strbuf := Format(	'AXP-PI02 o͎s'#10#10 +
									 	'|[ga%02Xho͂܂',[bValue] );
	ResultMessage(strbuf);


	//---------------------------------------------------------
	// foCXJ
	//---------------------------------------------------------

	if Pi02wClose( wLogSocket ) = False Then begin
		ErrorMessage( wLogSocket );
		Halt;
	end;
	strbuf := Format('AXP-PI02 Close'#10#10 +
									 'LogSocket: %2d', [wLogSocket]);
	ResultMessage(strbuf);

	//---------------------------------------------------------
	// Axppi02.dll J
	//---------------------------------------------------------
	if Pi02wDllClose() = False Then begin
		ErrorMessage(PI02_SOCKET_AUTO);
		Halt;
	end;
	Halt;
end;

// ʂ\
procedure TMainForm.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;

// G[bZ[W\
procedure TMainForm.ErrorMessage(wLogSocket: Word);
var
	dwRes: 	DWord;
	strbuf: String;
begin
	dwRes := pi02wGetLastError(wLogSocket);

	case dwRes of PI02_ERR_WRAPDLL:
		strbuf := 'DLL Load error';
	else
		strbuf := Format('AXP-PI02 error'#10#10'Error code: %08xH',[dwRes]);
	end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.
