Attribute VB_Name = "Sample"
'*****************************************************************************
'* axppi02s.bas                                                              *
'*                                                                           *
'* AXP-PI02Tv\[X                                                    *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/10                                                              *
'*                                                                           *
'* ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                    *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szPI02 = "AXP-PI02"

Private Sub Main()

    Dim strbuf As String
    Dim dwDllVer As Long
    Dim dwDrvVer As Long
    Dim wLogSocket As Integer
    Dim ri As PI02_RESOURCE
    Dim Value As Byte

    '=========================================================================
    ' axppi02.dll ̎gp錾
    '=========================================================================
    If Pi02wDllOpen() = False Then
        ErrorMessage (PI02_SOCKET_AUTO)
        Exit Sub                ' axppi02.dll ̃[hɎs܂
    End If

    '=========================================================================
    ' o[W̎擾
    '=========================================================================
    If Pi02wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (PI02_SOCKET_AUTO)
        Exit Sub
    End If
    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version:    &H" + Hex(dwDllVer) + Chr(10) + _
             "Driver Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

    '=========================================================================
    ' AXP-PI02 ̎gp錾
    '=========================================================================
    wLogSocket = PI02_SOCKET_AUTO   ' gp̃foCX

    If Pi02wCreate(wLogSocket, 0, 0, 0) = False Then
        ErrorMessage (PI02_SOCKET_AUTO)
        Exit Sub
    End If
    strbuf = "AXP-PI02 Created" + Chr(10) + Chr(10) + _
          "LogSocket: " + Str(wLogSocket)

    ResultMessage (strbuf)

    '=========================================================================
    ' \[X擾
    '=========================================================================
    If Pi02wGetResource(wLogSocket, ri) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    strbuf = "Board Name: " + szPI02 + Chr(10) + _
             "IO Base Address1: &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IO Base Address2: &H" + Hex(ri.dwIOPortBase(2)) + _
             "-&H" + Hex(ri.dwIOPortBase(2) + ri.dwIOPortLength(2) - 1)
    ResultMessage (strbuf)

    '=========================================================================
    ' 샂[h̐ݒ
    ' |[g`     ڂ́A戵
    ' |[ga o    ut^A. 샂[hꗗv
    ' |[gb o    QƂB
    '=========================================================================

    ' fBNV 15h 
    If Pi02wSetDirection(wLogSocket, &H15) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    ' R}h|[g 90h 
    If Pi02wOutPort(wLogSocket, PI02_PORT_CMD, &H90) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    ' fBNV 39h 
    If Pi02wSetDirection(wLogSocket, &H39) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    ' fBNV 28h 
    If Pi02wSetDirection(wLogSocket, &H28) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "샂[h:" + Chr(10) + _
             "|[g`@@" + Chr(10) + _
             "|[ga@@o" + Chr(10) + _
             "|[gb@@o" + Chr(10)
    ResultMessage (strbuf)

    '=========================================================================
    ' ͎s
    '=========================================================================
    If Pi02wInPort(wLogSocket, PI02_PORT_A, Value) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "InPort:" + Chr(10) + _
             "port A   &H" + Hex(Value)
    ResultMessage (strbuf)

    '=========================================================================
    ' o͎s
    '=========================================================================
    Value = &HAA
    If Pi02wOutPort(wLogSocket, PI02_PORT_B, Value) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    strbuf = "OunPort:" + Chr(10) + _
             "port B  &H" + Hex(Value) + " o͂܂"
    ResultMessage (strbuf)

    '=========================================================================
    ' AXP-PI02 J
    '=========================================================================
    If Pi02wClose(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    ResultMessage ("AXP-PI02 Closed")

    '=========================================================================
    ' axppi02.dll J
    '=========================================================================
    If Pi02wDllClose() = False Then
        ErrorMessage (PI02_SOCKET_AUTO)
        Exit Sub
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)

    MsgBox lpszbuf, vbOKOnly + vbInformation
End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)

    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Pi02wGetLastError(wLogSlot)

    Select Case dwRes
    Case PI02_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇ
        szbuf = "AXP-PI02 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub


