Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* axppi02w.bas                                                              *
'*                                                                           *
'* AXP-PI02                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/10                                                              *
'*                                                                           *
'*****************************************************************************

Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const PI02_DLL_NAME = "axppi02.dll"  ' DLL

Dim hDLL As Long                            ' DLLւ̃nh

Global Const PI02_ERR_WRAPDLL = -1          ' bp[֐G[

'*****************************************************************************
'*    axppi02.dll[h                                                *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wDllOpen() As Boolean

    Pi02wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(PI02_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Pi02wGetDllExportFunc() = False Then
        Pi02wDllClose   ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Pi02wDllOpen = True

End Function

'*****************************************************************************
'*    axppi02.dllA[h                                            *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wDllClose() As Boolean

    Pi02wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Pi02wDllClose = False

End Function

'*****************************************************************************
'*    AXP-PI02 DLL,Driver̃o[Wԍ擾                            *
'*    pdwDllVer DLLo[Wԍi[                                  *
'*        pdwDrvVer Drivero[Wԍi[                               *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean

    Pi02wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Pi02GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Pi02wGetVersion = True

End Function

'*****************************************************************************
'*    AXP-PI02̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSocket gpfoCXi[AhX                     *
'*        hWnd        bZ[W𑗂EBhEnh                     *
'*        uWMBase     ƂȂ郁bZ[WID                                 *
'*        pvInitArg   gp(0Zbg)                                      *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wCreate(ByRef pwLogSocket As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Long) As Boolean

    Pi02wCreate = False

    If hDLL = 0 Then Exit Function

    If Pi02Create(pwLogSocket, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Pi02wCreate = True

End Function

'*****************************************************************************
'*    AXP-PI02̔Cӂ̃foCX̎gpJ                               *
'*    wLogSocket gpfoCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wClose(ByVal wLogSlocket As Integer) As Boolean

    Pi02wClose = False

    If hDLL = 0 Then Exit Function

    If Pi02Close(wLogSlocket) = 0 Then Exit Function

    Pi02wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlocket ׂfoCX                                         *
'*        pres        \[Xi[\                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wGetResource(ByVal wLogSlocket As Integer, ByRef pres As PI02_RESOURCE) As Boolean

    Pi02wGetResource = False

    If hDLL = 0 Then Exit Function

    If Pi02GetResource(wLogSlocket, pres) = 0 Then Exit Function

    Pi02wGetResource = True

End Function

'*****************************************************************************
'*    |[g``bɑ΂PoCg                                     *
'*    wLogSlocket   ͂foCX                                     *
'*        dwPort        |[gԍ                                           *
'*        pbValue       ̓f[^i[AhX                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wInPort(ByVal wLogSlocket As Integer, ByVal dwPort As Long, ByRef pbValue As Byte) As Boolean

    Pi02wInPort = False
    
    If hDLL = 0 Then Exit Function

    If Pi02InPort(wLogSlocket, dwPort, pbValue) = 0 Then Exit Function

    Pi02wInPort = True

End Function

'*****************************************************************************
'*    |[g``bA܂̓R}h|[gւPoCgo                   *
'*    wLogSlocket  o͂foCX                                      *
'*        dwPort       |[gԍ                                            *
'*        bValue       o͂f[^                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wOutPort(ByVal wLogSlocket As Integer, ByVal dwPort As Long, ByVal bValue As Byte) As Boolean

    Pi02wOutPort = False
    
    If hDLL = 0 Then Exit Function

    If Pi02OutPort(wLogSlocket, dwPort, bValue) = 0 Then Exit Function

    Pi02wOutPort = True

End Function

'*****************************************************************************
'*    fBNV|[gɏo                                         *
'*    wLogSlocket   o͂foCX                                     *
'*        bDirectionBit fBNVrbg                                 *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Pi02wSetDirection(ByVal wLogSlocket As Integer, ByVal bDirectionBit As Byte) As Boolean

    Pi02wSetDirection = False
    
    If hDLL = 0 Then Exit Function

    If Pi02SetDirection(wLogSlocket, bDirectionBit) = 0 Then Exit Function

    Pi02wSetDirection = True

End Function

'*****************************************************************************
'*    AXP-PI02̃G[R[h                                             *
'*    wLogSlocket  G[foCX                              *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Pi02wGetLastError(ByVal wLogSlocket As Integer) As Long

    Pi02wGetLastError = PI02_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Pi02wGetLastError = Pi02GetLastError(wLogSlocket)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Pi02wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Pi02wGetDllExportFunc = False

    ' Pi02GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02GetVersion")
    If pFunc = 0 Then Exit Function

    ' Pi02Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02Create")
    If pFunc = 0 Then Exit Function

    ' Pi02Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02Close")
    If pFunc = 0 Then Exit Function

    ' Pi02GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02GetResource")
    If pFunc = 0 Then Exit Function

    ' Pi02InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02InPort")
    If pFunc = 0 Then Exit Function

    ' Pi02OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02OutPort")
    If pFunc = 0 Then Exit Function

    ' Pi02SetDirection ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02SetDirection")
    If pFunc = 0 Then Exit Function

    ' Pi02GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Pi02GetLastError")
    If pFunc = 0 Then Exit Function

    Pi02wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function


